//---------------------------------------------------------------------------

#include <vcl.h>
#include <Registry.hpp>
#pragma hdrstop

#include "Main.h"
#include "Utils.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
//===========================================================================
//= PRIVATE =================================================================
//===========================================================================
void __fastcall TMainForm::LoadFromReg()
{
    AnsiString as;
    TRegistry *MyReg = new TRegistry(KEY_READ|KEY_WOW64_64KEY);
    if (MyReg)
    {
        try
        {
            MyReg->RootKey = HKEY_LOCAL_MACHINE;
            if (MyReg->OpenKey(RK_WINLOGON,false))
            {
                edUser->Text = MyReg->ReadString(RV_USER);
                edDomain->Text = MyReg->ReadString(RV_DOMAIN);
                edPass->Text = MyReg->ReadString(RV_PASS);
                as = MyReg->ReadString(RV_ENABLED);
                chkEnableAL->Checked = (as == "1");
                as = MyReg->ReadString(RV_FORCE);
                chkForceAL->Enabled = chkEnableAL->Checked;
                chkForceAL->Checked = (as == "1");
                MyReg->CloseKey();
            }
        }
        __finally
        {
            delete MyReg;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SaveToReg()
{
    TRegistry *MyReg = new TRegistry(KEY_WRITE|KEY_WOW64_64KEY);
    if (MyReg)
    {
        try
        {
            MyReg->RootKey = HKEY_LOCAL_MACHINE;
            if (MyReg->OpenKey(RK_WINLOGON,false))
            {
                RegWriteValue(MyReg,RV_USER,edUser->Text);
                RegWriteValue(MyReg,RV_DOMAIN,edDomain->Text);
                RegWriteValue(MyReg,RV_PASS,edPass->Text);
                if (chkEnableAL->Checked)
                {
                    RegDeleteValue(MyReg,RV_COUNT);
                    RegWriteValue(MyReg,RV_ENABLED,"1");
                }
                else
                    RegWriteValue(MyReg,RV_ENABLED,"0");
                if (chkForceAL->Checked)
                    RegWriteValue(MyReg,RV_FORCE,"1");
                else
                    RegDeleteValue(MyReg,RV_FORCE);
            }
        }
        __finally
        {
            delete MyReg;
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::CreateSystemMenu()
{
    HMENU hSysMenu = GetSystemMenu(this->Handle,false);
    AppendMenu(hSysMenu,MF_SEPARATOR,0,"");
    AppendMenu(hSysMenu,MF_STRING,WM_ABOUT,"About");
}
//===========================================================================
//= PROTECTED ===============================================================
//===========================================================================
void __fastcall TMainForm::RegWriteValue(TRegistry *RegObj, const AnsiString Name, const AnsiString Value)
{
    try
    {
        RegObj->WriteString(Name,Value);
    }
    catch (EAccessViolation *e) {}
    catch (ERegistryException *e) {}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RegDeleteValue(TRegistry *RegObj, const AnsiString Name)
{
    try
    {
        RegObj->DeleteValue(Name);
    }
    catch (EAccessViolation *e) {}
    catch (ERegistryException *e) {}
}
//===========================================================================
//= PUBLIC ==================================================================
//===========================================================================
void __fastcall TMainForm::About()
{
    AnsiString as = Application->Title+" v0.1\n 2016 Black Manticore\nhttp://www.blackmanticore.com/";
    Application->MessageBox(as.c_str(),Application->Title.c_str(),MB_OK);
}
//===========================================================================
//= PUBLISHED ===============================================================
//===========================================================================
void __fastcall TMainForm::FormCreate(TObject *Sender)
{
    CreateSystemMenu();
    FixFont(this);
    LoadFromReg();
    btnOk->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ModifiedEvent(TObject *Sender)
{
    btnOk->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::chkEnableALClick(TObject *Sender)
{
    chkForceAL->Enabled = chkEnableAL->Checked;
    ModifiedEvent(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnCancelClick(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnOkClick(TObject *Sender)
{
    btnOk->Enabled = false;
    SaveToReg();
    btnCancel->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::btnClearClick(TObject *Sender)
{
    edUser->Text = "";
    edDomain->Text = "";
    edPass->Text = "";
    chkEnableAL->Checked = false;
    chkForceAL->Checked = false;
    ModifiedEvent(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AppEventsMessage(tagMSG &Msg, bool &Handled)
{
    if (Msg.message == WM_SYSCOMMAND && Msg.wParam == WM_ABOUT)
    {
        this->About();
        Handled = true;
    }
}
//---------------------------------------------------------------------------
