//---------------------------------------------------------------------------

#include <vcl.h>
#include <shellapi.h>
#include <shlobj.h>
#include <winnetwk.h>
#include <Lmcons.h>
#ifndef SECURITY_WIN32
    #define SECURITY_WIN32
#endif
#include <security.h>
#include <secext.h>
#pragma hdrstop

#include "Utils.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)
//---------------------------------------------------------------------------
bool __fastcall UserIsAdmin()
{
    SID_IDENTIFIER_AUTHORITY NtAuthority = SECURITY_NT_AUTHORITY;
    PSID AdministratorsGroup;
    int b = AllocateAndInitializeSid(&NtAuthority,2,SECURITY_BUILTIN_DOMAIN_RID,DOMAIN_ALIAS_RID_ADMINS,0, 0, 0, 0, 0, 0,&AdministratorsGroup);
    if (b)
    {
        if (!CheckTokenMembership(NULL,AdministratorsGroup,&b))
            b = false;
        FreeSid(AdministratorsGroup);
    }
    return (bool)b;
}
//---------------------------------------------------------------------------
void __fastcall FixFont(TCustomForm *FixForm)
{
    AnsiString FontName;
    int FontSize;
    NONCLIENTMETRICS *met;
    bool GotSPI;
    met = new NONCLIENTMETRICS;
    if (met)
    {
        met->cbSize = sizeof(NONCLIENTMETRICS);
        if (SystemParametersInfo(SPI_GETNONCLIENTMETRICS,sizeof(NONCLIENTMETRICS),met,0))
        {
            FontName = AnsiString(met->lfMessageFont.lfFaceName);
            FontSize = MulDiv(-met->lfMessageFont.lfHeight,72,GetDeviceCaps(GetDC(FixForm->Handle), LOGPIXELSY));
            GotSPI = true;
        }
        else
            GotSPI = false;
        delete met;
    }
    else
        GotSPI = false;
    if (!GotSPI)
    {
        if (Screen->Fonts->IndexOf(FONT_WIN7) > -1)
        {
            FontName = FONT_WIN7;
            FontSize = 9;
        }
        else
        {
            if (Screen->Fonts->IndexOf(FONT_WIN2K) == -1)
                FontName = FONT_WIN9X;
            FontSize = 8;
        }
    }
    try
    {
        FixForm->Font->Name = FontName;
        FixForm->Font->Size = FontSize;
    }
    catch (EAccessViolation *e) {}
}
//---------------------------------------------------------------------------
bool __fastcall IsWin2K()
{
    OSVERSIONINFOEX vix;
    DWORDLONG dwlConditionMask = 0;
    int op = VER_GREATER_EQUAL;
    ZeroMemory(&vix,sizeof(OSVERSIONINFOEX));
    vix.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
    vix.dwMajorVersion = 5;
    vix.dwMinorVersion = 0;
    dwlConditionMask = VerSetConditionMask(dwlConditionMask,VER_MAJORVERSION,op);
    dwlConditionMask = VerSetConditionMask(dwlConditionMask,VER_MINORVERSION,op);
    return VerifyVersionInfo(&vix,VER_MAJORVERSION|VER_MINORVERSION,dwlConditionMask);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

